import os
import re
import ch_scripts as pr1
import subprocess


def findgaps(input, object):
    gaps = []
    for i, j in enumerate(input):
        if j == object:
            gaps.append(str(i))
    return gaps
#----------------------------------------------------------------------------
#PART 2
#now we are creating array with blocks. [i][names and sequences]
#cog
#blocks_written
#blocks_output[][]
#blocks[]
#blout
##filename
def part_2_files_for_blocks (filename, blout):
    cog = open(filename+'_output.aln_1','r')
    blocks_written=0
    blocks_output = []
    seq_names = []
    for line in cog:
        if line.startswith(">BLOCKS"):
            pass
        elif line.startswith(">"):
            seq_names.append(line.replace('\n','\t').replace('\r',''))
            #for i in range(len(blocks)):
            #    blocks_output[i].append(line.replace('\r\n','\t'))
        else:
            if blocks_written==0:
                blocks_written=1
                blocks = [m.span() for m in re.finditer('[^-]{1,}[^-\r\n]', line)] #looking for pattern
                #print ('blocks = '+str(blocks))
                pr1.crdir(blout)
                for i in range(len(blocks)):
                    blocks_output.append(i)
                    blocks_output[i]=[]
            else:
                for i in range(len(blocks)):
                    blocks_output[i].append((line[blocks[i][0]:blocks[i][1]]+'\r\n'))
    #print ('blocks_output= ' + str(blocks_output))
    cog.close()
    #print ('seq_names= ' + str(seq_names))
    return {'blocks_output':blocks_output, 'seq_names':seq_names, 'blout':blout, 'blocks':blocks}
#----------------------------------------------------------------------------
#PART 3
#output
##blout
##blocks_output
###CHANGE_DIR
#ch_2 = in "blout"
#b#locks_output - [i][name'\t', sequence'\r\n'], i - block. len(blocks_output) = len(blocks)
def part_3_write_blocks(filename, blocks, blocks_output, seq_names):
    output = open(filename, 'w')
    output_2 = open(filename + '_blockdist','w')
    blocks_2 = list(blocks)
    output_2.writelines(str(blocks_2).replace('[','').replace(']','').replace('(','').replace('),','\t').replace(')','').replace(', ',':'))
    for i in range(len(blocks)):
        output.writelines('# STOCKHOLM 1.0'+'\r\n')
        output.writelines('#=GF ID BLOCK_' +str(i) + '\r\n')
        for k in range(len(blocks_output[i])):
            output.writelines(seq_names[k])
            output.writelines(blocks_output[i][k])
        output.writelines('//'+'\r\n\r\n')
    output_2.close()
    output.close() #without closing it hmmer won't work
#Now we need HMMer

#----------------------------------------------------------------------------
#Part 4
#genomes_database
#hmmplace
#number_of_seqs_1
#aaa_genomes
#hmmscan_out
#linename
#part_4_database
##folder
##blout
##filename
##genomes_database
def part_4_1_hmmer(input1, output):
    os.system("hmmbuild --amino --fragthresh 0 "+output+".hmm "+input1)
    os.system("hmmpress "+output+".hmm")
    #genomes_database = input('write the name of genomes database, please\r\n')
    #blout = 'blocks_output'
def part_4_hmmscan(input2, genomes_database_path, hmmscan_output, options):
    os.system("hmmscan --noali " + options +" "+input2+" "+genomes_database_path+" > "+hmmscan_output)
def part_4_hmmsearch(input2, genomes_database_path, hmmscan_output, options):
    os.system(
    "hmmsearch " + options + " " + input2 + " " + genomes_database_path + " > " + hmmscan_output)
def part_4_2_genomes_database(genomes_database_path):
    aaa_genomes = open(genomes_database_path, 'r')
    number_of_seqs_1 = 0
    part_4_database = {}
    #fill part_4_database
    for line in aaa_genomes:
        if line.startswith('>'):
            linename = line.replace('>', '').replace('\n', '').replace('\r', '')
            number_of_seqs_1 += 1
        elif line.startswith('\r\n'):
            pass
        else:
            part_4_database[linename]=line.replace('\n', '').replace('\r', '')
    aaa_genomes.close()
    return {'part_4_database':part_4_database, 'number_of_seqs_1':number_of_seqs_1}
#----------------------------------------------------------------------------
#Part 5
#Now we are trying to get blocks from hmm files.
#hmmblocks
#blockname
#iti
#work
#blcsn
#wrkf
#hblocks{}
#a_blocks{}
#b_blocks{}
##blocks
##filename
##number_of_seqs_1
##part_4_database
def part_5_search_blocks(blcsn, filename, number_of_seqs_1, database, hmmscan_1):
    #print database
    wrkf = open(hmmscan_1, 'r')
    #print(blocks)
    #print ('blcsn= '+str(blcsn))
    hmmid=[]
    hblocks={}
    a_blocks={}
    b_blocks={}
    hmmimportant=open(filename+"_hmm_important_findings", 'w')
    hmmimportant.writelines('Maybe, you should try to look at these sequences. Some of them might be important.\n')
    hmmwrk=open(filename+"_all_blocks_in", 'w')
    iti = -1
    hmmidd = []
    sumorgiti = 0
    wrkorgiti = 0
    for line in wrkf:
        if line.startswith("Query:"):
            hmmblocks=[]
            blockname = "NAN"
            organism=line.strip().split()[1] #addname
            organism_seq = database[organism]
            #print ('organism_seq= '+organism_seq)
            orgiti=0
            work = 0
            for line in wrkf:
                if line.startswith(">>"):
                    blockname = (line.replace('>>', '').replace(' ','').replace('\n',""))
                    work = 0
                    for line in wrkf:
                        if re.match(r'\s{1,3}\d\s!', line):
                            if work == 0:
                                wrkln = line.strip().split()
                                work += 1
                            elif work == 1:
                                hmmimportant.writelines('\n---------------------------------------------\n>> '+organism+'\n')
                                hmmimportant.writelines(blockname+'\n')
                                hmmimportant.writelines('! or ?\ti-Evalue\tstart\tend\tsequence\n')
                                hmmimportant.writelines(wrkln[1]+'\t'+wrkln[5]+'\t\t'+wrkln[9]+'\t'+wrkln[10]+'\t'+organism_seq[int(wrkln[9]):int(wrkln[10])]+'\n')
                                wrkln = line.strip().split()
                                hmmimportant.writelines(wrkln[1]+'\t'+wrkln[5]+'\t\t'+wrkln[9]+'\t'+wrkln[10]+'\t'+organism_seq[int(wrkln[9]):int(wrkln[10])]+'\n')
                                work += 1
                                # if we have more than one good example of profile in seq, then we need to work with it after...
                                # More than one '?' is not good too, but probability of it being something important is too low
                                # If I make everything in time, then I need to do something with those things.
                            else:
                                wrkln = line.strip().split()
                                #print('organism')
                                #print(organism)
                                hmmimportant.writelines(wrkln[1]+'\t'+wrkln[5]+'\t\t'+wrkln[9]+'t'+wrkln[10]+'\t'+organism_seq[int(wrkln[9]):int(wrkln[10])]+'\n')
                                work += 1
                        elif re.match('\n', line):
                            if work > 1:
                                orgiti = 1
                                wrkorgiti += 1
                                break
                                #and new block
                            elif work == 0:
                                break
                            else:
                                hmmblocks.append([blockname,wrkln[9],wrkln[10], organism_seq[int(wrkln[9]):int(wrkln[10])]])
                            break
                            #and new block
                if line.startswith("//"):
                    if work == 0:
                        hmmidd.append(organism)
                    elif work == 1:
                        iti += 1
                        hmmid.append(organism)
                        sumorgiti+=orgiti
                        #print ('unsorted '+str(hmmblocks))
                        hmmblocks.sort(key=lambda a_block: a_block[0])
                        #print ('sorted ' + str(hmmblocks))
                        #print (hmmid[iti])
                        hblocks[hmmid[iti]]=hmmblocks
                        #print (str(hblocks[hmmid[iti]])+'\n\n')
                        #work = 0
                    break
                    #and new organism
            #hmmid.append(line.replace("Query:\t","").replace(aaa, ""))
        #elif line.startswith()
    #print blocks
    #print('wrkorgiti= '+str(wrkorgiti))
    #print ('sumorgiti= '+str(sumorgiti))
    #print ('hmmidd (no blocks) = '+str(len(hmmidd)))
    #print ('hblocks= '+str(len(hblocks)))
    #print ('number_of_seqs_1= '+str(number_of_seqs_1))
    #print ('part_4_database= '+str(len(part_4['part_4_database'])))
    if len(hmmidd) > 0:
        hmmimportant.writelines('\n---------------------------------------------\n')
        hmmimportant.writelines('no blocks were found for: \n')
        for k in hmmidd:
            #print ('hmmidd '+k)
            hmmimportant.writelines('>> '+k+'\n')
    #Part 5
    #hmmblocks
    #blockname
    #iti
    #work
    #blcsn
    #wrkf
    #hblocks{}
    #a_blocks{}
    #b_blocks{}
    #----------------------------------------------------------------------------
    #PART 6 we need to put everything in new file
    #blcs
    #print len(hmmid)
    #print len(hblocks)
    ##blcsn
    ##hblocks
    ##number_of_seqs_1
    ##hmmwrk

    blcs=[blcsn-k-1 for k in range(blcsn)]
    for k in range(blcsn):
        blcs[k]=[]
    #print k
    #print blcs[k]
    #print blcs
    #blcsn - len(blocks)
    for i in hblocks:
        #print ('i '+i)
        for k in range(blcsn):
            #print ('in range ',i, hblocks[i])
            if len(hblocks[i]) == blcsn - k:
                #print (i, hblocks[i])
                blcs[k].append([i,hblocks[i]])
                break
            elif len(hblocks[i])==0:
                pass
                #print ('hblocks[i]= '+str(hblocks[i]))
                #print ('i= '+str(i))
    #print ('#--------------------------------------------------------# '+str(blcs))
    otherseq = len(database)
    for k in range(blcsn):
        #print k
        if blcsn-k == 1:
            hmmwrk.writelines('-Number of sequences with ' + str(blcsn-k) + ' block = ' + str(len(blcs[k]))+'\n')
            otherseq -= len(blcs[k])
            #print (len(blcs[k]))
            hmmwrk.writelines('-Number of sequences without blocks = ' + str(otherseq) + '\n')
        else:
            hmmwrk.writelines('-Number of sequences with ' + str(blcsn-k) + ' blocks = '+ str(len(blcs[k]))+'\n')
            otherseq -= len(blcs[k])
            #print (len(blcs[k]))
    for k in range(blcsn):
        hmmwrk.writelines('\n#NUMBER OF BLOCKS: '+str(blcsn-k)+'\n')
        hmmwrk.writelines('#NUMBER OF SEQUENCES: '+str(len(blcs[k]))+'\n')
        #print("PART_5 "+str(len(blcs[k])))
        for l in range(len(blcs[k])):
            #print blcs[k][l]
            #print blcs[k][l][0]
            #print blcs[k][l][1]
            hmmwrk.writelines('\n>> '+blcs[k][l][0]+'\n')
            hmmwrk.writelines('name\tstart\tend\tsequence\n')
            #print blcs[k][l]
            for x in blcs[k][l][1]:
                hmmwrk.writelines('\t'.join(x)+'\n')
            hmmwrk.writelines('//')
        hmmwrk.writelines('\\\\'+'\n')
    wrkf.close()
    hmmimportant.close()
    hmmwrk.close()
#------------------------------------------------------------------------------------------------
def part_5_searchblocksinhmm(filename, database, hmmsearch):
    wrkf = open(hmmsearch, 'r')
    hmmimportant = open(filename + "_hmm_important_findings", 'w')
    hmmimportant.writelines('Maybe, you should try to look at these sequences. Some of them might be important.\n')
    hmmwrk = open(filename + "_all_blocks_in", 'w')
    #blocks = []
    org = {}
    database_2 = list(database)
    wrkorgiti = 0
    blockiti = 0
    nblocks = []
    for line in wrkf:
        if line.startswith('Query'):
            if line.startswith('Query model'):
                pass
            else:
                block = line.strip().split()[1]
                hmmname = line.strip().split()[2].replace('[M=','').replace(']','')
                nblocks.append(0)
                blockiti += 1
                for line in wrkf:
                    if line.startswith('//'):
                        break
                    else:
                        if line.startswith('>>'):
                            organism = line.replace('>>', '').replace(' ','').replace('\n','').replace('\r','')
                            organism_seq = database[organism]
                            if organism in org:
                                pass
                            else:
                                org[organism]=[]
                                database_2.remove(organism)
                            work = 0
                            domiti = 0
                            domlist = []
                            workiti = 0
                            for line in wrkf:
                                if re.match(r'\s{1,3}\d\s!', line):
                                    if (work == 0):
                                        wrkln = line.strip().split()
                                        blocks = []
                                        wrkln[1] = str(wrkln[0])+'_'+wrkln[1]
                                        blocks += [block,[wrkln[1],wrkln[5], hmmname, wrkln[6], wrkln[7], wrkln[9], wrkln[10], organism_seq[int(wrkln[9])-1:int(wrkln[10])]]]
                                        work += 1
                                        domiti += 1
                                        domlist.append(int(wrkln[0]))
                                    elif work == 1:
                                        hmmimportant.writelines(
                                            '\n---------------------------------------------\n>> ' + organism + '\n')
                                        hmmimportant.writelines(block + '\n')
                                        hmmimportant.writelines('! or ?\ti-Evalue\thmmlength\thmmstart\thmmend\tseqstart\tseqend\tsequence\n')
                                        hmmimportant.writelines(
                                            wrkln[1] + '\t' + wrkln[5] + '\t' + hmmname +'\t' + wrkln[6] + '\t' + wrkln[7] + '\t' + wrkln[9] + '\t' + wrkln[
                                                10] + '\t' + organism_seq[int(wrkln[9])-1:int(wrkln[10])] + '\n')
                                        wrkln = line.strip().split()
                                        wrkln[1] = str(wrkln[0]) + '_' + wrkln[1]
                                        blocks += [[wrkln[1],wrkln[5], hmmname, wrkln[6], wrkln[7], wrkln[9], wrkln[10], organism_seq[int(wrkln[9])-1:int(wrkln[10])]]]
                                        hmmimportant.writelines(
                                            wrkln[1] + '\t' + wrkln[5] + '\t' + hmmname + '\t' + wrkln[6] + '\t' +
                                            wrkln[7] + '\t' + wrkln[9] + '\t' + wrkln[
                                                10] + '\t' + organism_seq[int(wrkln[9])-1:int(wrkln[10])] + '\n')
                                        work += 1
                                        domiti += 1
                                        domlist.append(int(wrkln[0]))
                                        # if we have more than one good example of profile in seq, then we need to work with it after...
                                        # More than one '?' is not good too, but probability of it being something important is too low
                                        # If I make everything in time, then I need to do something with those things.
                                    else:
                                        wrkln = line.strip().split()
                                        wrkln[1] = str(wrkln[0]) + '_' + wrkln[1]
                                        blocks += [[wrkln[1], wrkln[5], hmmname, wrkln[6], wrkln[7], wrkln[9], wrkln[10],
                                                    organism_seq[int(wrkln[9])-1:int(wrkln[10])]]]
                                        # print('organism')
                                        # print(organism)
                                        hmmimportant.writelines(
                                            wrkln[1] + '\t' + wrkln[5] + '\t'+ hmmname + '\t' + wrkln[6] + '\t' + wrkln[7] + '\t' + wrkln[9] + '\t' + wrkln[
                                                10] + '\t' + organism_seq[int(wrkln[9])-1:int(wrkln[10])] + '\n')
                                        work += 1
                                        domiti += 1
                                        domlist.append(int(wrkln[0]))
                                elif line.startswith('\n'):
                                    if domiti > 0:
                                        for line in wrkf:
                                            if (re.match(r'\s{1,3}==', line)):
                                                if int(line.strip().split()[2]) == domlist[0]:
                                                    for line in wrkf:
                                                        if (line.strip().split()[0] == block):
                                                            phyloblock_seq = line.strip().split()[2]
                                                            gaps = findgaps(phyloblock_seq, '.')+findgaps(phyloblock_seq, '-')
                                                        elif (line.strip().split()[0] == organism):
                                                            subseq = line.strip().split()[2]
                                                            subseqgaps = findgaps(subseq, '.')+findgaps(subseq, '-')
                                                            if len(gaps) > 0:
                                                                blocks[workiti + 1].append('_'.join(gaps))
                                                            else:
                                                                blocks[workiti + 1].append('NAN')
                                                            if len(subseqgaps) > 0:
                                                                blocks[workiti + 1].append('_'.join(subseqgaps))
                                                            else:
                                                                blocks[workiti + 1].append('NAN')
                                                            workiti += 1
                                                            break
                                                    domlist.remove(domlist[0])
                                                    domiti -= 1
                                                    break
                                                else:
                                                    break
                                    elif work > 1:
                                        orgiti = 1
                                        wrkorgiti += 1
                                        break
                                        # and new block
                                    elif work == 0:
                                        break
                                    else:
                                        if len(org[organism]) == 0:
                                            nblocks[0] += 1
                                        else:
                                            nblocks[len(org[organism])-1] -= 1
                                            nblocks[len(org[organism])] += 1
                                        org[organism].append(blocks)
                                        break
                                #elif re.match(r'\s{1,3}\d\s?', line):
                                #    domiti += 1
                                    #domlist.append(domiti - 1)

    orgs_block = []
    for organism in org:
        orgs_block.append([organism, org[organism]])
    orgs_block.sort(key= lambda nblock: len(nblock[1]))
    orgs_block = orgs_block[::-1]
    otherseq = len(database)
    for i in range(blockiti):
        # print k
        if blockiti - i == 1:
            hmmwrk.writelines('-Number of sequences with ' + str(blockiti - i) + ' block = ' + str(nblocks[blockiti - i - 1]) + '\n')
            otherseq -= nblocks[blockiti - i - 1]
            # print (len(blcs[k]))
            #hmmwrk.writelines('-Number of sequences without blocks = ' + str(otherseq) + '\n')
            hmmwrk.writelines('-Number of sequences with ambiguous blocks = ' + str(otherseq - len(database_2)) + '\n')
            hmmwrk.writelines('-Number of sequences without blocks = ' + str(len(database_2)) + '\n')
        else:
            hmmwrk.writelines('-Number of sequences with ' + str(blockiti - i) + ' blocks = ' + str(nblocks[blockiti - i - 1]) + '\n')
            otherseq -= nblocks[blockiti - i - 1]
            # print (len(blcs[k]))
    plus = 0
    for i in range(blockiti):
        hmmwrk.writelines('\n#NUMBER OF BLOCKS: ' + str(blockiti - i) + '\n')
        hmmwrk.writelines('#NUMBER OF SEQUENCES: ' + str(nblocks[blockiti - i - 1]) + '\n')
        # print("PART_5 "+str(len(blcs[k])))
        for l in range(nblocks[blockiti - i - 1]):
            # print blcs[k][l]
            # print blcs[k][l][0]
            # print blcs[k][l][1]
            hmmwrk.writelines('\n>> ' + orgs_block[l+plus][0] + '\n')
            hmmwrk.writelines('name\t! or ?\ti-Evalue\thmmlength\thmmstart\thmmend\tseqstart\tseqend\tsequence\thmmgaps\tseqgaps\n')
            # print blcs[k][l]
            for x in orgs_block[l+plus][1]:
                for y in range(len(x)-1):
                    hmmwrk.writelines(x[0]+'\t'+'\t'.join(x[y+1])+'\n')
            hmmwrk.writelines('//\n')
        plus += nblocks[blockiti - i - 1]
        hmmwrk.writelines('\\\\' + '\n')
    hmmimportant.writelines('\n---------------------------------------------\n')
    hmmimportant.writelines('ambiguous blocks were found for: \n')
    for l in range(otherseq - len(database_2)):
        hmmimportant.writelines('>> '+ orgs_block[l+plus][0] + '\n' + database[orgs_block[l+plus][0]] + '\n')
    hmmimportant.writelines('\n---------------------------------------------\n')
    hmmimportant.writelines('no blocks were found for: \n')
    for organism in database_2:
        hmmimportant.writelines('>> ' + organism + '\n' + database[organism]+ '\n')
    wrkf.close()
    hmmimportant.close()
    hmmwrk.close()
#------------------------------------------------------------------------------------------------

def unused_get_sequences(database_path, sequences, output_file):
    seqname = []
    for i in sequences:
        seqname.append(i.replace('\t', ''))
    seqname.sort()
    database = open(database_path, 'r')
    wrk_genomes_database = []
    for line in database:
        if line.startswith('>'):
            aaa = line.replace('\r\n', '')
            for line in database:
                if line.startswith('\r\n'):
                    break
                else:
                    wrk_genomes_database.append([aaa, line])
    wrk_genomes_database.sort(key=lambda a_block: a_block[0])
    #print seqname
    #print wrk_genomes_database
    database.close()
    wrkfile_1 = open(output_file, 'w')
    unused_get_sequences_seq=[]
    wrkfile_2 = open('not_'+output_file, 'w')
    i=0
    k=0
    for genome in wrk_genomes_database:
        if i > len(seqname) - 1:
            wrkfile_2.writelines(genome[0] + '\r\n' + genome[1])
            k += 1
        elif genome[0] == seqname[i]:
            wrkfile_1.writelines(genome[0] + '\r\n' + genome[1])
            unused_get_sequences_seq.append([genome[0], genome[1]])
            i += 1
        else:
            wrkfile_2.writelines(genome[0] + '\r\n' + genome[1])
            k += 1
    wrkfile_1.close()
    wrkfile_2.close()
    return {'seqnames':seqname, 'sequences':unused_get_sequences_seq}
def get_sequences(sequences_path, output_file):
    seqname = []
    database = open(sequences_path, 'r')
    output = open(output_file,'w')
    i = -2
    sequences_database={}
    for line in database:
        #print 'aaa'
        #print line
        if i == -2:
            if line.startswith(">BLOCKS"):
                pass
            else:
                i += 1
        elif line.startswith(">"):
            seqname.append('\r\n'+line)
            linename = line.replace('>', '').replace('\n', '').replace('\r','')
            i += 1
        else:
            sequence_1 = line.replace('-','')
            seqname[i] = seqname[i]+sequence_1
            sequences_database[linename]=sequence_1.replace('\n', '').replace('\r','')
    #print sequences_database
    output.writelines(seqname)
    database.close()
    output.close()
    number_of_sequences = len(seqname)
    return{'sequences_database':sequences_database, 'number_of_sequences':number_of_sequences}

def changephyloformat(inp, outp):
    inpfile = open(inp, 'r')
    wrkfile = open(outp, 'w')
    for line in inpfile:
        if line.startswith('('):
            wrkfile.writelines(line)
        else:
            aaa = line.strip().split(':')
            if (len(aaa) == 2):
                wrkfile.writelines(line)
            elif (len(aaa) > 2):
                iti = 0
                while iti < len(aaa):
                    if iti < 2:
                        wrkfile.writelines(aaa[0]+':'+aaa[1]+'\n')
                        iti += 2
                    else:
                        wrkfile.writelines(':'+aaa[iti]+'\n')
                        iti += 1
            else:
                print ('error. len(aaa) cannot be < 2')
                break
    inpfile.close()
    wrkfile.close()
#START

